(function () {
    'use strict';

    class GameConfig {
        constructor() {
        }
        static init() {
            var reg = Laya.ClassUtils.regClass;
        }
    }
    GameConfig.width = 750;
    GameConfig.height = 1334;
    GameConfig.scaleMode = "fixedauto";
    GameConfig.screenMode = "none";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "fc-layout/view/AdHomePage.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    class EventConst {
    }
    EventConst.SHOW_SUCCESS = "SHOW_SUCCESS";
    EventConst.SHOW_FAILED = "SHOW_FAILED";
    EventConst.CHANGE_CUR_MODEL = "CHANGE_CUR_MODEL";
    EventConst.ADD_PASSENGER = "ADD_PASSENGER";
    EventConst.REMOVE_PASSENGER = "REMOVE_PASSENGER";
    EventConst.CARRIAGE_BOMB = "CARRIAGE_BOMB";
    EventConst.SCORE_TIP_POP = "SCORE_TIP_POP";
    EventConst.ITEM_TRIGGERD = "ITEM_TRIGGERD";
    EventConst.ITEM_WAKEUP = "ITEM_WAKEUP";
    EventConst.ITEM_SLEEP = "ITEM_SLEEP";
    EventConst.Camera_2_Far = "Camera_2_Far";
    EventConst.Camera_2_Near = "Camera_2_Near";
    EventConst.KEY_UPDATE = "KEY_UPDATE";

    class GameData {
        static get GoldCollected() {
            return this.sGoldCollected;
        }
        static set GoldCollected(val) {
            this.sGoldCollected = val;
        }
        static get KeyCollected() {
            return GameData.sKeyCollected;
        }
        static set KeyCollected(value) {
            GameData.sKeyCollected = value;
        }
        static get PlayerInfo() {
            return fc.framework.GameFrame.playerInfo;
        }
        static get GoodsCfg() {
            return fc.framework.GameFrame.goodsCfg;
        }
        static get GameScore() {
            return this.sGameScore;
        }
        static set GameScore(val) {
            this.sGameScore = val;
        }
        static get IsInGame() {
            return fc.framework.GameFrame.gameSceneId == fc.define.SceneId.Game;
        }
    }
    GameData.sGoldCollected = 0;
    GameData.sGameScore = 0;

    class GameConst {
    }
    GameConst.VectorForward = new Laya.Vector3(0, 0, 1);
    GameConst.VectorRight = new Laya.Vector3(-1, 0, 0);
    GameConst.VectorUp = new Laya.Vector3(0, 1, 0);
    GameConst.VectorZero = new Laya.Vector3(0, 0, 0);
    GameConst.VectorOne = new Laya.Vector3(1, 1, 1);
    GameConst.Float2Int = 10000;
    GameConst.Int2Float = 0.0001;
    GameConst.MoveSpeed = 14;
    GameConst.MaxAdditiveSpeed = 6;
    GameConst.RotateSpeed = Math.PI * 2;
    GameConst.CameraSpeed = 18;
    GameConst.CameraMaxDist = 8;
    GameConst.CarriageSize = 2;
    GameConst.CarriageInverval = 1.5;
    GameConst.CarriageRotateRad = Math.PI * 0.15;
    GameConst.CarriageRotateDuaration = 1000;
    GameConst.PassengerTweenDuaration = 200;
    GameConst.ItemRotateSpd = 180;

    class ResConst {
    }
    ResConst.Color_White = new Laya.Vector4(1, 1, 1, 1);
    ResConst.Color_Gray = new Laya.Vector4(0.5, 0.5, 0.5, 1);
    ResConst.ObjType_Path = 0;
    ResConst.ObjType_Student = 1;
    ResConst.ObjType_ColorGate = 2;
    ResConst.ObjType_ButtonGate = 3;
    ResConst.Prefab_Briack_Straight_12 = "LevelBrick_Straight_12";
    ResConst.Prefab_Briack_Straight_24 = "LevelBrick_Straight_24";
    ResConst.Prefab_StartBricks = [
        "LevelBrick_Straight_24_Looping_24",
        "LevelBrick_Straight_24_FlipV2",
        "LevelBrick_Straight_36_InverseLoop",
        "LevelBrick_Straight_36_Looping_Circle",
        "LevelBrick_Straight_24_Looping_Whirlwind"
    ];
    ResConst.Prefab_EndBricks = [
        "LevelBrick_FinishLine",
        "LevelBrick_Slop5_Currency",
        "LevelBrick_Straight_24_Looping_24",
        "LevelBrick_End_Station_Long",
        "LevelBrick_Straight_12_Lock",
        "LevelBrick_Straight_24_FlipV2",
        "LevelBrick_End_Station_Short",
        "LevelBrick_Straight_12_Lock",
        "LevelBrick_Straight_36_InverseLoop",
        "LevelBrick_End_Station_Short",
        "LevelBrick_Straight_12_Lock",
        "LevelBrick_Straight_36_Looping_Circle",
        "LevelBrick_End_Station_Short",
        "LevelBrick_Straight_12_Lock",
        "LevelBrick_Straight_24_Looping_Whirlwind",
        "LevelBrick_End_Station_Short"
    ];
    ResConst.Prefab_Passenger = "Skin_Default";
    ResConst.Prefab_Carriage_Container = "CarriageContainer";
    ResConst.Prefab_Bomb_Efc = "ef_bomb_01";
    ResConst.Prefab_Get_Key_Efc = "ef_get_key";
    ResConst.Prefab_Get_Coin_Efc = "ef_get_coins";
    ResConst.Anim_Passenger_Fly = "fly";
    ResConst.Anim_Passenger_Idle = "idle";
    ResConst.Anim_Passenger_Dance = "dance";
    ResConst.Anim_Passenger_Waving = "waving";
    ResConst.Anim_PadLock_Default = "default";
    ResConst.Anim_PadLock_Open = "open";
    ResConst.SubPkg_Skin = "3dskin";
    ResConst.SubPkg_Scene = null;
    ResConst.Sound_Ext = Laya.Render.isConchApp ? ".wav" : ".mp3";
    ResConst.Sound_Cry = [
        "sound/S_Little_Cry_1" + ResConst.Sound_Ext,
        "sound/S_Little_Cry_2" + ResConst.Sound_Ext,
        "sound/S_Little_Cry_3" + ResConst.Sound_Ext,
        "sound/S_Little_Cry_4" + ResConst.Sound_Ext,
    ];
    ResConst.Sound_Death = [
        "sound/S_Death01" + ResConst.Sound_Ext,
        "sound/S_Death02" + ResConst.Sound_Ext,
        "sound/S_Death03" + ResConst.Sound_Ext,
        "sound/S_Death04" + ResConst.Sound_Ext,
    ];
    ResConst.Sound_Win = "sound/S_Victory" + ResConst.Sound_Ext;
    ResConst.Sound_Lose = "sound/S_Lose" + ResConst.Sound_Ext;
    ResConst.Sound_Wind = "sound/S_Wind" + ResConst.Sound_Ext;
    ResConst.Sound_Yell = "sound/S_Yell" + ResConst.Sound_Ext;
    ResConst.Sound_Flyer = "sound/S_CoinStoring" + ResConst.Sound_Ext;
    ResConst.Sound_Wahou = "sound/S_Wahou" + ResConst.Sound_Ext;
    ResConst.Sound_Station = "sound/S_CoinPoping" + ResConst.Sound_Ext;
    ResConst.Sound_RailLoop = "sound/S_RailLoop" + ResConst.Sound_Ext;
    ResConst.Sound_DriftLoop = "sound/S_DriftLoop" + ResConst.Sound_Ext;
    ResConst.Sound_Bomb = "sound/S_Bomb_Explosion_A" + ResConst.Sound_Ext;
    ResConst.Sound_Unlock = "sound/S_Unlock" + ResConst.Sound_Ext;
    ResConst.Sound_Collected = "sound/S_CoinPoping" + ResConst.Sound_Ext;
    ResConst.Sound_WallBreak = "sound/S_BrickWallDestruction" + ResConst.Sound_Ext;

    class Camera extends fc.plugin.GameObj {
        constructor() {
            super(...arguments);
            this.mInAnim = false;
            this.mCurDist = 0;
            this.mDstDist = 0;
            this.mDefaultDist = 0;
            this.mCameraOrient = new Laya.Vector3();
            this.mCamera = null;
            this.speedEfc = null;
            this.mIsFollow = true;
            this.scale = new Laya.Vector3();
            this.position = new Laya.Vector3();
            this.rotation = new Laya.Quaternion();
        }
        init() {
            this.mCamera = this.Sprite.getChildByName("Main Camera");
            this.speedEfc = this.mCamera.getChildByName("effectRoot");
            this.mCamera.transform.localPosition.cloneTo(this.mCameraOrient);
            this.mDefaultDist = Laya.Vector3.scalarLength(this.mCameraOrient);
            Laya.Vector3.normalize(this.mCameraOrient, this.mCameraOrient);
            this.mCurDist = this.mDstDist = this.mDefaultDist;
            Laya.stage.on(EventConst.Camera_2_Far, this, this.onCamera2Far);
            Laya.stage.on(EventConst.Camera_2_Near, this, this.onCamera2Near);
        }
        reset() {
            this.mInAnim = false;
            this.mIsFollow = true;
            this.speedEfc.active = false;
            fc.framework.Audio.stopSound(ResConst.Sound_Wind);
            this.Sprite.transform.localPosition.setValue(0, 0, 0);
            this.Sprite.transform.localPosition = this.Sprite.transform.localPosition;
            this.Sprite.transform.localRotation.identity();
            this.Sprite.transform.localRotation = this.Sprite.transform.localRotation;
            this.mCurDist = this.mDstDist = this.mDefaultDist;
            Laya.Vector3.scale(this.mCameraOrient, this.mCurDist, this.mCamera.transform.localPosition);
            this.mCamera.transform.localPosition = this.mCamera.transform.localPosition;
        }
        update(deltaTime, worldMatrix) {
            if (!this.mIsFollow) {
                return;
            }
            worldMatrix.decomposeTransRotScale(this.position, this.rotation, this.scale);
            var dist = Laya.Vector3.distance(this.position, this.Sprite.transform.localPosition);
            var moveDist = deltaTime * 0.001 * GameConst.CameraSpeed;
            if (dist > moveDist) {
                if (dist >= GameConst.CameraMaxDist) {
                    Laya.Vector3.lerp(this.Sprite.transform.localPosition, this.position, GameConst.CameraMaxDist / dist, this.Sprite.transform.localPosition);
                }
                else {
                    Laya.Vector3.lerp(this.Sprite.transform.localPosition, this.position, moveDist / dist, this.Sprite.transform.localPosition);
                }
            }
            else {
                this.position.cloneTo(this.Sprite.transform.localPosition);
            }
            if (dist > moveDist * 2) {
                if (this.speedEfc.active == false) {
                    this.speedEfc.active = true;
                    fc.framework.Audio.playSound(ResConst.Sound_Wind, true);
                }
            }
            else {
                if (this.speedEfc.active == true) {
                    this.speedEfc.active = false;
                    fc.framework.Audio.stopSound(ResConst.Sound_Wind);
                }
            }
            this.Sprite.transform.localPosition = this.Sprite.transform.localPosition;
            Laya.Quaternion.lerp(this.Sprite.transform.localRotation, this.rotation, deltaTime * 0.001 * 5, this.Sprite.transform.localRotation);
            this.Sprite.transform.localRotation = this.Sprite.transform.localRotation;
            if (this.mInAnim) {
                var moveDist = deltaTime * 0.001 * GameConst.CameraSpeed;
                if (this.mDstDist < this.mCurDist) {
                    this.mCurDist -= moveDist;
                    if (this.mCurDist <= this.mDstDist) {
                        this.mInAnim = false;
                        this.mCurDist = this.mDstDist;
                    }
                }
                else if (this.mDstDist > this.mCurDist) {
                    this.mCurDist += moveDist;
                    if (this.mCurDist >= this.mDstDist) {
                        this.mInAnim = false;
                        this.mCurDist = this.mDstDist;
                    }
                }
                else {
                    this.mInAnim = false;
                    this.mCurDist = this.mDstDist;
                }
                Laya.Vector3.scale(this.mCameraOrient, this.mCurDist, this.mCamera.transform.localPosition);
                this.mCamera.transform.localPosition = this.mCamera.transform.localPosition;
            }
        }
        onCamera2Far() {
            this.mInAnim = true;
            this.mDstDist = this.mDefaultDist * 3;
        }
        onCamera2Near() {
            this.mInAnim = true;
            this.mDstDist = this.mDefaultDist;
        }
    }

    class Passenger extends fc.plugin.GameObj {
        static create(sprite) {
            var script = sprite.getComponent(Passenger);
            if (script == null) {
                script = sprite.addComponent(Passenger);
            }
            return script;
        }
    }

    class Carriage extends fc.plugin.GameObj {
        constructor() {
            super(...arguments);
            this.direction = 0;
            this.passengers = [];
            this.worldMatrix = new Laya.Matrix4x4();
            this.carriageBody = null;
            this.sparkEfcL = null;
            this.sparkEfcR = null;
            this.curPosition = new Laya.Vector3();
            this.curRotation = new Laya.Quaternion();
            this.curScale = new Laya.Vector3();
            this.manPrefabId = "";
            this.inRotate = false;
        }
        static create(sprite, carPrefabId, manPrefabId, index) {
            var script = sprite.getComponent(Carriage);
            if (script == null) {
                script = sprite.addComponent(Carriage);
            }
            script.init(carPrefabId, manPrefabId, index);
            return script;
        }
        get CurRotateDirection() {
            return this.direction;
        }
        get PassengerCount() {
            return this.passengers.length;
        }
        get WorldMatrix() {
            return this.worldMatrix;
        }
        get Position() {
            return this.curPosition;
        }
        get Rotation() {
            return this.curRotation;
        }
        init(carPrefabId, manPrefabId, index) {
            this.inRotate = false;
            this.direction = 0;
            this.sparkEfcR = this.Sprite.getChildByName("ef_spark_r");
            this.sparkEfcL = this.Sprite.getChildByName("ef_spark_l");
            this.sparkEfcR.active = this.sparkEfcL.active = false;
            this.curPosition.setValue(0, 0, 0);
            this.curRotation.identity();
            this.curScale.setValue(1, 1, 1);
            this.Sprite.transform.localPosition.setValue(0, 0.5, index * -GameConst.CarriageInverval);
            this.Sprite.transform.localPosition = this.Sprite.transform.localPosition;
            this.Sprite.transform.localRotation.identity();
            this.Sprite.transform.localRotation = this.Sprite.transform.localRotation;
            this.Sprite.transform.localScale.setValue(1, 1, 1);
            this.Sprite.transform.localScale = this.Sprite.transform.localScale;
            if (this.carriageBody) {
                fc.plugin.ObjectPool.recoverSprite3d(this.carriageBody);
            }
            this.manPrefabId = manPrefabId;
            var model = fc.framework.Resource.loadSprite3d(carPrefabId, ResConst.SubPkg_Skin);
            this.carriageBody = fc.plugin.ObjectPool.getSprite3d(model);
            this.Sprite.addChild(this.carriageBody);
            this.carriageBody.transform.localPosition.setValue(0, 0, 0);
            this.carriageBody.transform.localPosition = this.carriageBody.transform.localPosition;
            this.carriageBody.transform.localRotation.identity();
            this.carriageBody.transform.localRotation = this.carriageBody.transform.localRotation;
            this.carriageBody.transform.localScale.setValue(0.2, 0.2, 0.2);
            this.carriageBody.transform.localScale = this.carriageBody.transform.localScale;
            Laya.Tween.to(this.carriageBody.transform, { localScaleX: 1, localScaleY: 1, localScaleZ: 1 }, 500, Laya.Ease.backOut);
        }
        release(atOnce) {
            this.sparkEfcR.active = this.sparkEfcL.active = false;
            while (this.PassengerCount > 0) {
                var passenger = this.passengers.pop();
                fc.plugin.ObjectPool.recoverSprite3d(passenger);
            }
            if (atOnce == false) {
                var position = this.carriageBody.transform.position.clone();
                var rotation = this.carriageBody.transform.rotation.clone();
                fc.framework.GameFrame.scene3d.addChild(this.carriageBody);
                this.carriageBody.transform.localPosition = position;
                this.carriageBody.transform.localRotation = rotation;
                var carriage = this.carriageBody;
                this.carriageBody = null;
                Laya.Tween.to(carriage.transform, { localScaleX: 0.2, localScaleY: 0.2, localScaleZ: 0.2 }, 500, Laya.Ease.backIn, Laya.Handler.create(null, (carriage) => {
                    fc.plugin.ObjectPool.recoverSprite3d(carriage);
                }, [carriage]));
            }
            else {
                fc.plugin.ObjectPool.recoverSprite3d(this.carriageBody);
                this.carriageBody = null;
            }
        }
        addPassenger(worldPosition, worldRotation) {
            if (this.PassengerCount + 1 > GameConst.CarriageSize) {
                return false;
            }
            var prefab = fc.framework.Resource.loadSprite3d(this.manPrefabId, ResConst.SubPkg_Skin);
            var passenger = fc.plugin.ObjectPool.getSprite3d(prefab);
            this.Sprite.addChild(passenger);
            this.passengers.push(passenger);
            passenger.active = true;
            Passenger.create(passenger).Animator.play(ResConst.Anim_Passenger_Waving);
            var transMatrix = new Laya.Matrix4x4();
            this.Sprite.transform.worldMatrix.invert(transMatrix);
            var rootScale = new Laya.Vector3();
            var rootPosition = new Laya.Vector3();
            var rootRotation = new Laya.Quaternion();
            transMatrix.decomposeTransRotScale(rootPosition, rootRotation, rootScale);
            if (worldPosition != null) {
                Laya.Vector3.transformCoordinate(worldPosition, transMatrix, passenger.transform.localPosition);
            }
            else {
                passenger.transform.localPosition.setValue(this.PassengerCount == 1 ? -0.45 : 0.45, 0, 0);
            }
            passenger.transform.localPosition = passenger.transform.localPosition;
            if (worldRotation != null) {
                Laya.Quaternion.multiply(rootRotation, worldRotation, passenger.transform.localRotation);
            }
            else {
                passenger.transform.localRotation.identity();
            }
            passenger.transform.localRotation = passenger.transform.localRotation;
            Laya.Tween.to(passenger.transform, { localPositionX: this.PassengerCount == 1 ? -0.45 : 0.45, localPositionZ: 0 }, GameConst.PassengerTweenDuaration * 2, null, null, null, false);
            Laya.Tween.to(passenger.transform, { localRotationEulerX: 0, localRotationEulerY: 0, localRotationEulerZ: 0 }, GameConst.PassengerTweenDuaration * 2, null, null, null, false);
            Laya.Tween.to(passenger.transform, { localPositionY: passenger.transform.localPositionY + 1 }, GameConst.PassengerTweenDuaration, Laya.Ease.strongOut, null, null, false);
            Laya.Tween.to(passenger.transform, { localPositionY: 0.1 }, GameConst.PassengerTweenDuaration, Laya.Ease.strongIn, null, GameConst.PassengerTweenDuaration, false);
            return true;
        }
        removePasssenger() {
            if (this.PassengerCount == 0) {
                return null;
            }
            var passenger = this.passengers.pop();
            var position = passenger.transform.position.clone();
            var rotation = passenger.transform.rotation.clone();
            fc.framework.GameFrame.scene3d.addChild(passenger);
            passenger.transform.localPosition = position;
            passenger.transform.localRotation = rotation;
            return passenger;
        }
        updatePositionRotation(deltaTime, worldMatrix, direction) {
            worldMatrix.cloneTo(this.worldMatrix);
            worldMatrix.decomposeTransRotScale(this.curPosition, this.curRotation, this.curScale);
            Laya.Vector3.transformCoordinate(Carriage.offsetPos, worldMatrix, this.Sprite.transform.position);
            this.Sprite.transform.position = this.Sprite.transform.position;
            if (this.inRotate == false) {
                this.inRotate = Math.abs(direction - this.direction) > 0.3;
            }
            else {
                var rotateDist = deltaTime * 0.001 * GameConst.RotateSpeed;
                if (direction < this.direction) {
                    this.direction = this.direction - rotateDist;
                    if (this.direction <= direction) {
                        this.inRotate = false;
                        this.direction = direction;
                    }
                }
                else if ((direction > this.direction)) {
                    this.direction = this.direction + rotateDist;
                    if (this.direction >= direction) {
                        this.inRotate = false;
                        this.direction = direction;
                    }
                }
                else {
                    this.inRotate = false;
                    this.direction = direction;
                }
            }
            if (this.direction != 0) {
                this.sparkEfcR.active = this.direction > 0;
                this.sparkEfcL.active = this.direction < 0;
                Laya.Quaternion.createFromAxisAngle(GameConst.VectorForward, this.direction * GameConst.CarriageRotateRad, Carriage.offsetRot);
                Laya.Quaternion.multiply(this.curRotation, Carriage.offsetRot, this.Sprite.transform.rotation);
            }
            else {
                this.sparkEfcR.active = this.sparkEfcL.active = false;
                this.curRotation.cloneTo(this.Sprite.transform.rotation);
                this.sparkEfcR.active = this.sparkEfcL.active = false;
            }
            this.Sprite.transform.rotation = this.Sprite.transform.rotation;
        }
    }
    Carriage.offsetPos = new Laya.Vector3(0, 0.4, 0);
    Carriage.offsetRot = new Laya.Quaternion();

    class ConfigManager {
        static get BrickGroups() {
            if (this.sBrickGroups == null) {
                this.sBrickGroups = Laya.loader.getRes("config/BrickGroups.json");
            }
            return this.sBrickGroups;
        }
        static get BricksMap() {
            if (this.sBricksMap == null) {
                this.sBricksMap = Laya.loader.getRes("config/BricksMap.json");
            }
            return this.sBricksMap;
        }
        static get BrickTracks() {
            if (this.sBrickTracks == null) {
                this.sBrickTracks = Laya.loader.getRes("config/BrickTracks.json");
            }
            return this.sBrickTracks;
        }
        static get ComboBrickList() {
            if (this.sComboBrickList == null) {
                this.sComboBrickList = Laya.loader.getRes("config/ComboBrickList.json");
            }
            return this.sComboBrickList;
        }
        static get GameLevelList() {
            if (this.sGameLevelList == null) {
                this.sGameLevelList = Laya.loader.getRes("config/GameLevelList.json");
            }
            return this.sGameLevelList;
        }
    }
    ConfigManager.sBrickGroups = null;
    ConfigManager.sBricksMap = null;
    ConfigManager.sBrickTracks = null;
    ConfigManager.sComboBrickList = null;
    ConfigManager.sGameLevelList = null;

    class Path {
    }
    class PathLoader {
        static get PathCount() {
            return this.pathList.length;
        }
        static findPath(index) {
            return this.pathList[index];
        }
        static clearPath() {
            this.pathList.splice(0);
        }
        static pushPath(path) {
            this.pathList.push(path);
        }
        static shiftPath() {
            return this.pathList.shift();
        }
        static isEmpty() {
            return this.pathList.length == 0;
        }
        static endWorldMat() {
            if (this.pathList.length == 0) {
                return null;
            }
            var path = this.pathList[this.pathList.length - 1];
            this.endPosition.fromArray(path.main, path.main.length - 7);
            this.endRotation.fromArray(path.main, path.main.length - 4);
            this.endMatrix.setPosition(this.endPosition);
            this.endMatrix.setRotation(this.endRotation);
            return this.endMatrix;
        }
        static mergePath() {
            for (let index = 1; index < this.pathList.length;) {
                const curPath = this.pathList[index];
                const prePath = this.pathList[index - 1];
                if (curPath.merge && prePath.merge) {
                    prePath.main = prePath.main.concat(curPath.main);
                    this.pathList.splice(index, 1);
                }
                else {
                    index++;
                }
            }
        }
        static loadPath(brickRoot) {
            for (let index = 0; index < brickRoot.numChildren; index++) {
                const birckChild = brickRoot.getChildAt(index);
                this.createPath(birckChild);
            }
        }
        static createPath(pathBrick) {
            var brickRoot = pathBrick.getChildByName("bricks");
            if (brickRoot == null) {
                this.createSimplePath(pathBrick);
            }
            else {
                for (let index = 0; index < brickRoot.numChildren; index++) {
                    const birckChild = brickRoot.getChildAt(index);
                    if (birckChild.name == "DoublePathSwitcher") {
                        this.createDoublePath(birckChild);
                    }
                    else {
                        this.createPath(birckChild);
                    }
                }
            }
        }
        static createSimplePath(pathBrick) {
            var brickCfg = ConfigManager.BrickTracks.list.find(val => { return val.brickId == pathBrick.name; });
            if (brickCfg != null) {
                var path = new Path();
                path.merge = brickCfg.brickId.indexOf("Straight") >= 0;
                path.main = [];
                this.loadPathNode(pathBrick, brickCfg, path.main);
                this.pushPath(path);
            }
            else {
                console.log("invalid pathBrickId:" + pathBrick);
            }
        }
        static createDoublePath(pathBrick) {
            var path = new Path();
            path.merge = false;
            path.branchL = [];
            var leftRoot = pathBrick.getChildByName("pathLeft");
            for (let i = 0; i < leftRoot.numChildren; i++) {
                const birckChild = leftRoot.getChildAt(i);
                var brickCfg = ConfigManager.BrickTracks.list.find(val => { return val.brickId == birckChild.name; });
                if (brickCfg != null) {
                    this.loadPathNode(birckChild, brickCfg, path.branchL);
                }
            }
            path.branchR = [];
            var rightRoot = pathBrick.getChildByName("pathRight");
            for (let i = 0; i < rightRoot.numChildren; i++) {
                const birckChild = rightRoot.getChildAt(i);
                var brickCfg = ConfigManager.BrickTracks.list.find(val => { return val.brickId == birckChild.name; });
                if (brickCfg != null) {
                    this.loadPathNode(birckChild, brickCfg, path.branchR);
                }
            }
            this.pushPath(path);
        }
        static loadPathNode(pathBrick, brickCfg, dataArry) {
            for (let i = 0; i < brickCfg.pathInfo.length;) {
                this.position.setValue(brickCfg.pathInfo[i++] * GameConst.Int2Float, brickCfg.pathInfo[i++] * GameConst.Int2Float, brickCfg.pathInfo[i++] * GameConst.Int2Float);
                Laya.Vector3.transformCoordinate(this.position, pathBrick.transform.worldMatrix, this.position);
                this.rotation.x = brickCfg.pathInfo[i++] * GameConst.Int2Float;
                this.rotation.y = brickCfg.pathInfo[i++] * GameConst.Int2Float;
                this.rotation.z = brickCfg.pathInfo[i++] * GameConst.Int2Float;
                this.rotation.w = brickCfg.pathInfo[i++] * GameConst.Int2Float;
                Laya.Quaternion.multiply(pathBrick.transform.rotation, this.rotation, this.rotation);
                dataArry.push(this.position.x, this.position.y, this.position.z);
                dataArry.push(this.rotation.x, this.rotation.y, this.rotation.z, this.rotation.w);
            }
        }
    }
    PathLoader.pathList = [];
    PathLoader.endMatrix = new Laya.Matrix4x4();
    PathLoader.endPosition = new Laya.Vector3();
    PathLoader.endRotation = new Laya.Quaternion();
    PathLoader.position = new Laya.Vector3();
    PathLoader.rotation = new Laya.Quaternion();

    class Driver {
        constructor() {
            this.mInTurn = false;
            this.mMouseX = 0;
            this.mOrient = 0;
            this.mPassedDist = 0;
            this.mMoveSpd = 0;
            this.mAdditiveSpeed = 0;
            this.mForwardTrack = [];
            this.mHistoryTrack = [];
            this.mCurPosition = new Laya.Vector3();
            this.mSrcPosition = new Laya.Vector3();
            this.mDstPosition = new Laya.Vector3();
            this.mCurRotation = new Laya.Quaternion();
            this.mSrcRotation = new Laya.Quaternion();
            this.mDstRotation = new Laya.Quaternion();
        }
        get Orient() {
            return this.mOrient;
        }
        get PassedDist() {
            return this.mPassedDist;
        }
        get Position() {
            return this.mCurPosition;
        }
        get Rotation() {
            return this.mCurRotation;
        }
        get MoveSpeed() {
            return this.mMoveSpd;
        }
        get AdditiveSpeed() {
            return this.mAdditiveSpeed;
        }
        set AdditiveSpeed(val) {
            this.mAdditiveSpeed = val;
        }
        reset() {
            this.mInTurn = false;
            this.mOrient = 0;
            this.mPassedDist = 0;
            this.mDstPosition.setValue(0, 0, 0);
            this.mSrcPosition.setValue(0, 0, 0);
            this.mCurPosition.setValue(0, 0, 0);
            this.mForwardTrack.splice(0);
            this.mHistoryTrack.splice(0);
        }
        startGame() {
            this.mInTurn = false;
            this.mMoveSpd = GameConst.MoveSpeed;
            this.mAdditiveSpeed = 0;
            this.mOrient = 0;
            this.move2NextLine();
            if (fc.platform.PlatformConfig.platformTag.indexOf("iptv") >= 0) {
                Laya.stage.on(fc.define.Event.GAMEPAD_DIRECTION_UPDATE, this, this.onMoveDirUpdate);
            }
            else {
                Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onStartRotate);
                Laya.stage.on(Laya.Event.MOUSE_UP, this, this.onStopRotate);
                Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.onRotating);
            }
        }
        stopGame() {
            this.mInTurn = false;
            this.mOrient = 0;
            if (fc.platform.PlatformConfig.platformTag.indexOf("iptv") >= 0) {
                Laya.stage.off(fc.define.Event.GAMEPAD_DIRECTION_UPDATE, this, this.onMoveDirUpdate);
            }
            else {
                Laya.stage.off(Laya.Event.MOUSE_DOWN, this, this.onStartRotate);
                Laya.stage.off(Laya.Event.MOUSE_UP, this, this.onStopRotate);
                Laya.stage.off(Laya.Event.MOUSE_MOVE, this, this.onRotating);
            }
        }
        isReachEndLine() {
            return PathLoader.isEmpty();
        }
        worldMatrixInPassed(dist, out) {
            var movedDist = dist;
            this.mCurPosition.cloneTo(Driver.srcPosition);
            this.mCurRotation.cloneTo(Driver.srcRotation);
            var offset = 0;
            Driver.dstPosition.fromArray(this.mHistoryTrack, offset);
            Driver.dstRotation.fromArray(this.mHistoryTrack, offset + 3);
            offset += 7;
            var nodeDist = Laya.Vector3.distance(Driver.srcPosition, Driver.dstPosition);
            while (movedDist > nodeDist) {
                if (offset < this.mHistoryTrack.length) {
                    Driver.dstPosition.cloneTo(Driver.srcPosition);
                    Driver.dstRotation.cloneTo(Driver.srcRotation);
                    Driver.dstPosition.fromArray(this.mHistoryTrack, offset);
                    Driver.dstRotation.fromArray(this.mHistoryTrack, offset + 3);
                    offset += 7;
                }
                else {
                    break;
                }
                movedDist -= nodeDist;
                nodeDist = Laya.Vector3.distance(Driver.srcPosition, Driver.dstPosition);
            }
            var amount = movedDist / nodeDist;
            Laya.Vector3.lerp(Driver.srcPosition, Driver.dstPosition, amount, Driver.cursorPosition);
            Laya.Quaternion.lerp(Driver.srcRotation, Driver.dstRotation, amount, Driver.cursorRotation);
            var worldMatrix = out || new Laya.Matrix4x4();
            worldMatrix.setPosition(Driver.cursorPosition);
            worldMatrix.setRotation(Driver.cursorRotation);
            return worldMatrix;
        }
        moveForward(deltaTime) {
            var movedDist = deltaTime * 0.001 * (this.mMoveSpd + this.mAdditiveSpeed);
            this.mPassedDist += movedDist;
            movedDist += Laya.Vector3.distance(this.mCurPosition, this.mSrcPosition);
            var nodeDist = Laya.Vector3.distance(this.mDstPosition, this.mSrcPosition);
            while (movedDist > nodeDist) {
                if (this.move2NextLine() == false) {
                    this.mDstPosition.cloneTo(this.mCurPosition);
                    this.mDstRotation.cloneTo(this.mCurRotation);
                    break;
                }
                movedDist -= nodeDist;
                nodeDist = Laya.Vector3.distance(this.mDstPosition, this.mSrcPosition);
            }
            var amount = movedDist / nodeDist;
            Laya.Vector3.lerp(this.mSrcPosition, this.mDstPosition, amount, this.mCurPosition);
            Laya.Quaternion.lerp(this.mSrcRotation, this.mDstRotation, amount, this.mCurRotation);
        }
        move2NextLine() {
            if (this.mForwardTrack.length < 14) {
                if (PathLoader.isEmpty()) {
                    return false;
                }
                var path = PathLoader.shiftPath();
                if (path.main != null) {
                    this.mForwardTrack = this.mForwardTrack.concat(path.main);
                }
                else {
                    if (this.mOrient < 0) {
                        if (path.branchL != null) {
                            this.mForwardTrack = this.mForwardTrack.concat(path.branchL);
                        }
                        else {
                            return false;
                        }
                    }
                    else {
                        if (path.branchR != null) {
                            this.mForwardTrack = this.mForwardTrack.concat(path.branchR);
                        }
                        else {
                            return false;
                        }
                    }
                }
            }
            this.mSrcPosition.fromArray(this.mForwardTrack, 0);
            this.mSrcRotation.fromArray(this.mForwardTrack, 3);
            this.mHistoryTrack = this.mForwardTrack.splice(0, 7).concat(this.mHistoryTrack);
            this.mDstPosition.fromArray(this.mForwardTrack, 0);
            this.mDstRotation.fromArray(this.mForwardTrack, 3);
            var memoryDist = 0;
            for (let index = 0; index < this.mHistoryTrack.length - 7; index += 7) {
                const x1 = this.mHistoryTrack[index];
                const y1 = this.mHistoryTrack[index + 1];
                const z1 = this.mHistoryTrack[index + 2];
                const x2 = this.mHistoryTrack[index + 7];
                const y2 = this.mHistoryTrack[index + 7 + 1];
                const z2 = this.mHistoryTrack[index + 7 + 2];
                memoryDist += Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2) + Math.pow(z1 - z2, 2));
            }
            if (memoryDist > 50) {
                this.mHistoryTrack.splice(this.mHistoryTrack.length - 7);
            }
            return true;
        }
        onStartRotate() {
            this.mMouseX = Laya.stage.mouseX;
            this.mOrient = 0;
        }
        onStopRotate() {
            this.mMouseX = -1;
            this.mOrient = 0;
            this.mInTurn = false;
            fc.framework.Audio.stopSound(ResConst.Sound_DriftLoop);
        }
        onRotating() {
            if (this.mMouseX < 0) {
                this.mMouseX = Laya.stage.mouseX;
                this.mOrient = 0;
            }
            else {
                if (this.mOrient == 0 || this.mOrient * (Laya.stage.mouseX - this.mMouseX) < 0) {
                    this.mInTurn = true;
                    if (GameData.IsInGame && this.mOrient == 0) {
                        fc.framework.Audio.playSound(ResConst.Sound_DriftLoop, true);
                    }
                    this.mOrient = Laya.stage.mouseX - this.mMouseX;
                    if (this.mOrient < 0) {
                        this.mOrient = -1;
                        console.log("Left");
                    }
                    else {
                        console.log("Right");
                        this.mOrient = 1;
                    }
                    this.mMouseX = Laya.stage.mouseX;
                }
            }
        }
        onMoveDirUpdate(x, y, isInOp) {
            this.mInTurn = isInOp != 0 && x != 0;
            if (this.mInTurn == false) {
                this.mOrient = 0;
                fc.framework.Audio.stopSound(ResConst.Sound_DriftLoop);
            }
            if (x != 0 && this.mOrient * x <= 0) {
                if (this.mOrient == 0) {
                    fc.framework.Audio.playSound(ResConst.Sound_DriftLoop, true);
                }
                if (x < 0) {
                    this.mOrient = -1;
                    console.log("Left");
                }
                else {
                    console.log("Right");
                    this.mOrient = 1;
                }
            }
        }
    }
    Driver.srcPosition = new Laya.Vector3();
    Driver.srcRotation = new Laya.Quaternion();
    Driver.dstPosition = new Laya.Vector3();
    Driver.dstRotation = new Laya.Quaternion();
    Driver.cursorPosition = new Laya.Vector3();
    Driver.cursorRotation = new Laya.Quaternion();

    class Coaster extends fc.plugin.GameObj {
        constructor() {
            super(...arguments);
            this.mCameraOffset = 0;
            this.mCarriages = [];
            this.mPassengerCount = 1;
            this.mScore = 0;
            this.mDriver = null;
            this.carPrefabId = null;
            this.manPrefabId = null;
            this.hitResult = [];
            this.worldMatrix = new Laya.Matrix4x4();
            this.colliderSrcPos = new Laya.Vector3();
            this.colliderDstPos = new Laya.Vector3();
        }
        get WorldMatrix() {
            if (this.mCarriages.length == 0) {
                return this.Sprite.transform.worldMatrix;
            }
            else if (this.mCarriages.length < 6) {
                this.mDriver.worldMatrixInPassed((this.mCarriages.length - 1) * GameConst.CarriageInverval - this.mCameraOffset, this.worldMatrix);
                return this.worldMatrix;
            }
            else {
                this.mDriver.worldMatrixInPassed(5 * GameConst.CarriageInverval - this.mCameraOffset, this.worldMatrix);
                return this.worldMatrix;
            }
        }
        get Score() {
            return this.mScore;
        }
        set Score(val) {
            this.mScore = val;
        }
        init() {
            this.mDriver = new Driver();
            this.Rigidbody.enabled = false;
        }
        reset() {
            this.mDriver.reset();
            this.Score = 0;
            this.mCameraOffset = 0;
            this.mPassengerCount = 1;
            this.Sprite.transform.localPosition.setValue(0, 0, 0);
            this.Sprite.transform.localPosition = this.Sprite.transform.localPosition;
            this.Sprite.transform.localRotation.identity();
            this.Sprite.transform.localRotation = this.Sprite.transform.localRotation;
            for (let index = 0; index < this.mCarriages.length; index++) {
                this.mCarriages[index].release(true);
                fc.plugin.ObjectPool.recoverSprite3d(this.mCarriages[index].Sprite);
            }
            this.mCarriages.splice(0);
            this.carPrefabId = "";
            this.manPrefabId = "";
            fc.framework.Audio.stopSound(ResConst.Sound_RailLoop);
            this.changeCarriage(GameData.GoodsCfg[0][GameData.PlayerInfo.goodsInUse[0]].prefab, GameData.GoodsCfg[1][GameData.PlayerInfo.goodsInUse[1]].prefab);
        }
        changeCarriage(carPrefabId, manPrefabId) {
            if (this.carPrefabId == carPrefabId && this.manPrefabId == manPrefabId) {
                return;
            }
            this.carPrefabId = carPrefabId;
            this.manPrefabId = manPrefabId;
            fc.framework.Resource.loadSprite3dAsyn([carPrefabId, manPrefabId], Laya.Handler.create(this, this.onPrefabReady, [carPrefabId, manPrefabId]), null, ResConst.SubPkg_Skin);
        }
        update(deltaTime) {
            if (this.mDriver.isReachEndLine()) {
                return;
            }
            if (this.mCarriages.length == 0) {
                return;
            }
            if (this.mCarriages[0].PassengerCount == 0) {
                this.mCarriages[0].release(false);
                this.mCarriages.shift();
                if (this.mCarriages.length == 0) {
                    return;
                }
            }
            var movedDist = deltaTime * 0.001 * (this.mDriver.MoveSpeed + this.mDriver.AdditiveSpeed);
            var relativeDist = Laya.Vector3.distance(this.mDriver.Position, this.mCarriages[0].Position);
            if (relativeDist <= movedDist) {
                this.mDriver.moveForward(deltaTime);
                this.hitResult.splice(0);
                this.worldMatrix.setPosition(this.mDriver.Position);
                this.worldMatrix.setRotation(this.mDriver.Rotation);
                this.colliderSrcPos.setValue(this.mDriver.Orient * -1, 0, 0);
                Laya.Vector3.transformCoordinate(this.colliderSrcPos, this.Sprite.transform.worldMatrix, this.colliderSrcPos);
                this.colliderDstPos.setValue(this.mDriver.Orient * -1, 0, 0);
                Laya.Vector3.transformCoordinate(this.colliderDstPos, this.worldMatrix, this.colliderDstPos);
                fc.framework.GameFrame.scene3d.physicsSimulation.shapeCastAll(this.Rigidbody.colliderShape, this.colliderSrcPos, this.colliderDstPos, this.hitResult, this.Sprite.transform.localRotation, this.mDriver.Rotation);
                this.mDriver.Position.cloneTo(this.Sprite.transform.localPosition);
                this.Sprite.transform.localPosition = this.Sprite.transform.localPosition;
                this.mDriver.Rotation.cloneTo(this.Sprite.transform.localRotation);
                this.Sprite.transform.localRotation = this.Sprite.transform.localRotation;
                relativeDist = 0;
                if (this.hitResult.length > 0) {
                    for (let index = 0; index < this.hitResult.length; index++) {
                        const sprite = this.hitResult[index].collider.owner;
                        const script = sprite.getComponent(fc.plugin.Trigger3dListener);
                        if (script) {
                            script.onTriggerEnter(this.Rigidbody);
                        }
                        else {
                            this.onTriggerEnter(this.hitResult[index].collider);
                        }
                    }
                }
            }
            else {
                relativeDist -= movedDist;
            }
            var curRotateDirection = this.mDriver.Orient;
            for (let index = 0; index < this.mCarriages.length; index++) {
                this.mDriver.worldMatrixInPassed(index * GameConst.CarriageInverval + relativeDist, this.worldMatrix);
                this.mCarriages[index].updatePositionRotation(deltaTime, this.worldMatrix, curRotateDirection);
                curRotateDirection = this.mCarriages[index].CurRotateDirection;
            }
            if (this.mCameraOffset > 0) {
                movedDist = deltaTime * 0.001 * this.mDriver.MoveSpeed;
                this.mCameraOffset = Math.max(0, this.mCameraOffset - movedDist);
            }
        }
        startGame() {
            this.mDriver.startGame();
            fc.framework.Audio.playSound(ResConst.Sound_RailLoop, true);
            Laya.stage.on(EventConst.CARRIAGE_BOMB, this, this.onCarriageBomb);
            Laya.stage.on(EventConst.ADD_PASSENGER, this, this.onAddPassenger);
            Laya.stage.on(EventConst.REMOVE_PASSENGER, this, this.onRemovePassenger);
        }
        stopGame() {
            this.mDriver.stopGame();
            fc.framework.Audio.stopSound(ResConst.Sound_RailLoop);
            Laya.stage.off(EventConst.CARRIAGE_BOMB, this, this.onCarriageBomb);
            Laya.stage.off(EventConst.ADD_PASSENGER, this, this.onAddPassenger);
            Laya.stage.off(EventConst.REMOVE_PASSENGER, this, this.onRemovePassenger);
        }
        onPrefabReady(carPrefabId, manPrefabId) {
            if (carPrefabId != this.carPrefabId || manPrefabId != this.manPrefabId) {
                return;
            }
            for (let index = 0; index < this.mCarriages.length; index++) {
                this.mCarriages[index].release(true);
                fc.plugin.ObjectPool.recoverSprite3d(this.mCarriages[index].Sprite);
            }
            this.mCarriages.splice(0);
            var container = fc.framework.Resource.loadSprite3d(ResConst.Prefab_Carriage_Container);
            const sprite = fc.plugin.ObjectPool.getSprite3d(container);
            this.Sprite.addChild(sprite);
            this.mCarriages.push(Carriage.create(sprite, this.carPrefabId, this.manPrefabId, this.mCarriages.length));
            this.mCarriages[0].addPassenger(null, null);
        }
        onCarriageBomb() {
            if (this.mCarriages.length == 0) {
                return;
            }
            fc.plugin.Effect3d.createEffect({
                customId: ResConst.Prefab_Bomb_Efc,
                sign: ResConst.Prefab_Bomb_Efc,
                duaration: 1200,
                parent: this.owner.parent,
                isWorldSpace: false,
                position: new Laya.Vector3(0, 1, 0)
            });
            fc.framework.Audio.playSound(ResConst.Sound_Bomb);
            fc.framework.Audio.playSound(ResConst.Sound_Death[Math.floor(Math.random() * ResConst.Sound_Death.length)]);
            var carriage = this.mCarriages[0];
            var index = 0;
            while (carriage.PassengerCount > 0) {
                this.mPassengerCount--;
                var passenger = carriage.removePasssenger();
                var dstPos = new Laya.Vector3(index == 1 ? -3 : 3, 0, -3);
                Laya.Vector3.transformCoordinate(dstPos, passenger.transform.localMatrix, dstPos);
                console.log("srcPos:" + JSON.stringify(passenger.transform.localPosition));
                console.log("dstPos:" + JSON.stringify(dstPos));
                Laya.Tween.to(passenger.transform, { localPositionX: dstPos.x, localPositionZ: dstPos.z }, GameConst.PassengerTweenDuaration * 4, null, null, null, false);
                Laya.Tween.to(passenger.transform, { localPositionY: dstPos.y + 3 }, GameConst.PassengerTweenDuaration * 2, Laya.Ease.strongOut, null, null, false);
                Laya.Tween.to(passenger.transform, { localPositionY: dstPos.y }, GameConst.PassengerTweenDuaration * 2, Laya.Ease.strongIn, Laya.Handler.create(null, (obj) => {
                    fc.plugin.ObjectPool.recoverSprite3d(obj);
                }, [passenger]), GameConst.PassengerTweenDuaration * 2, false);
                index++;
            }
            console.log(`[onCarriageBomb]leftCarriage:${this.mCarriages.length}, leftPassenger:${this.mPassengerCount}`);
            if (this.mPassengerCount == 0) {
                this.owner.timerOnce(1000, null, () => {
                    Laya.stage.event(EventConst.SHOW_FAILED);
                });
            }
        }
        onAddPassenger(srcPosition, srcRotation) {
            this.mPassengerCount++;
            var container = fc.framework.Resource.loadSprite3d(ResConst.Prefab_Carriage_Container);
            if (this.mCarriages.length == 0 || this.mCarriages[this.mCarriages.length - 1].PassengerCount == GameConst.CarriageSize) {
                const sprite = fc.plugin.ObjectPool.getSprite3d(container);
                this.Sprite.addChild(sprite);
                this.mCarriages.push(Carriage.create(sprite, this.carPrefabId, this.manPrefabId, this.mCarriages.length));
                this.mCameraOffset = GameConst.CarriageInverval;
            }
            this.mCarriages[this.mCarriages.length - 1].addPassenger(srcPosition, srcRotation);
        }
        onRemovePassenger(dstPoint) {
            if (dstPoint == null) {
                return;
            }
            for (let index = 0; index < dstPoint.length; index++) {
                this.mPassengerCount--;
                var carriage = this.mCarriages[0];
                var passenger = carriage.removePasssenger();
                var position = passenger.transform.position.clone();
                var rotation = passenger.transform.rotation.clone();
                dstPoint[index].addChild(passenger);
                var transMatrix = new Laya.Matrix4x4();
                dstPoint[index].transform.worldMatrix.invert(transMatrix);
                var rootScale = new Laya.Vector3();
                var rootPosition = new Laya.Vector3();
                var rootRotation = new Laya.Quaternion();
                transMatrix.decomposeTransRotScale(rootPosition, rootRotation, rootScale);
                Laya.Vector3.transformCoordinate(position, transMatrix, passenger.transform.localPosition);
                passenger.transform.localPosition = passenger.transform.localPosition;
                Laya.Quaternion.multiply(rootRotation, rotation, passenger.transform.localRotation);
                passenger.transform.localRotation = passenger.transform.localRotation;
                Passenger.create(passenger).Animator.play(ResConst.Anim_Passenger_Dance);
                Laya.Tween.to(passenger.transform, { localPositionY: 2 }, GameConst.PassengerTweenDuaration, Laya.Ease.strongOut, null, null, false);
                Laya.Tween.to(passenger.transform, { localPositionY: 0 }, GameConst.PassengerTweenDuaration, Laya.Ease.strongIn, null, GameConst.PassengerTweenDuaration, false);
                Laya.Tween.to(passenger.transform, { localPositionX: 0, localPositionZ: 0, localRotationEulerX: 0, localRotationEulerY: 180, localRotationEulerZ: 0 }, GameConst.PassengerTweenDuaration * 2, null, null, null, false);
                if (carriage.PassengerCount == 0) {
                    fc.framework.Audio.playSound(ResConst.Sound_Wahou);
                    break;
                }
            }
            if (this.mPassengerCount == 0) {
                this.owner.timerOnce(1000, null, () => {
                    Laya.stage.event(EventConst.SHOW_SUCCESS);
                });
            }
        }
        onTriggerEnter(other) {
            if (other.owner.name == "SpeedTrigger_Increase_Big" || other.owner.name == "BoostStation") {
                if (this.mDriver.AdditiveSpeed != GameConst.MaxAdditiveSpeed) {
                    fc.framework.Audio.playSound(ResConst.Sound_Cry[Math.floor(Math.random() * ResConst.Sound_Cry.length)]);
                }
                this.mDriver.AdditiveSpeed = GameConst.MaxAdditiveSpeed;
            }
            else if (other.owner.name == "SpeedTrigger_Increase_Small") {
                if (this.mDriver.AdditiveSpeed != GameConst.MaxAdditiveSpeed) {
                    fc.framework.Audio.playSound(ResConst.Sound_Cry[Math.floor(Math.random() * ResConst.Sound_Cry.length)]);
                }
                this.mDriver.AdditiveSpeed = Math.min(GameConst.MaxAdditiveSpeed, this.mDriver.AdditiveSpeed + GameConst.MaxAdditiveSpeed * 0.5);
            }
            else if (other.owner.name == "SpeedTrigger_Decrease_Big" || other.owner.name == "Station" || other.owner.name.startsWith("MultiplierPartController")) {
                if (this.mDriver.AdditiveSpeed != 0) {
                    fc.framework.Audio.playSound(ResConst.Sound_Cry[Math.floor(Math.random() * ResConst.Sound_Cry.length)]);
                }
                this.mDriver.AdditiveSpeed = 0;
            }
            else if (other.owner.name == "SpeedTrigger_Decrease_Small") {
                if (this.mDriver.AdditiveSpeed != 0) {
                    fc.framework.Audio.playSound(ResConst.Sound_Cry[Math.floor(Math.random() * ResConst.Sound_Cry.length)]);
                }
                this.mDriver.AdditiveSpeed = Math.max(0, this.mDriver.AdditiveSpeed - GameConst.MaxAdditiveSpeed * 0.5);
            }
            else if (other.owner.name == "CameraTrigger") {
                Laya.stage.event(EventConst.Camera_2_Far);
            }
        }
    }

    class BrickLoader {
        static loadBrick(brickId, output, transMat) {
            var comboBrickCfg = ConfigManager.ComboBrickList.list.find((val) => { return val.brickId == brickId; });
            if (comboBrickCfg != null) {
                if (comboBrickCfg.envs.objData.length > 0) {
                    this.loadObjs(comboBrickCfg.envs, transMat, output.envs);
                }
                if (comboBrickCfg.items.objData.length > 0) {
                    this.loadObjs(comboBrickCfg.items, transMat, output.items);
                }
                if (comboBrickCfg.bricks.objData.length > 0) {
                    var rootPosition = new Laya.Vector3();
                    var rootRotation = new Laya.Quaternion();
                    var rootScale = new Laya.Vector3();
                    if (transMat) {
                        transMat.decomposeTransRotScale(rootPosition, rootRotation, rootScale);
                    }
                    var objsInfo = comboBrickCfg.bricks;
                    var objPosition = new Laya.Vector3();
                    var objRotation = new Laya.Quaternion();
                    var objScale = new Laya.Vector3(1, 1, 1);
                    for (var i = 0; i < objsInfo.objData.length;) {
                        var prefabIdx = objsInfo.objData[i++];
                        var prefabId = objsInfo.prefabInfo[prefabIdx];
                        objPosition.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                        objRotation.x = objsInfo.objData[i++] * GameConst.Int2Float;
                        objRotation.y = objsInfo.objData[i++] * GameConst.Int2Float;
                        objRotation.z = objsInfo.objData[i++] * GameConst.Int2Float;
                        objRotation.w = objsInfo.objData[i++] * GameConst.Int2Float;
                        objScale.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                        if (transMat) {
                            Laya.Vector3.transformCoordinate(objPosition, transMat, objPosition);
                            Laya.Quaternion.multiply(rootRotation, objRotation, objRotation);
                        }
                        var worldMat = new Laya.Matrix4x4();
                        worldMat.identity();
                        worldMat.setTranslationVector(objPosition);
                        worldMat.setRotation(objRotation);
                        this.loadBrick(prefabId, output, worldMat);
                    }
                }
            }
            else {
                var rootPosition = new Laya.Vector3();
                var rootRotation = new Laya.Quaternion();
                var rootScale = new Laya.Vector3(1, 1, 1);
                if (transMat) {
                    transMat.decomposeTransRotScale(rootPosition, rootRotation, rootScale);
                }
                var newPrefabIdx = output.bricks.prefabInfo.indexOf(brickId);
                if (newPrefabIdx == -1) {
                    output.bricks.prefabInfo.push(brickId);
                    newPrefabIdx = output.bricks.prefabInfo.length - 1;
                }
                output.bricks.objData.push(newPrefabIdx, rootPosition.x, rootPosition.y, rootPosition.z, rootRotation.x, rootRotation.y, rootRotation.z, rootRotation.w, 1, 1, 1);
            }
        }
        static loadObjs(input, transMat, output) {
            var rootPosition = new Laya.Vector3();
            var rootRotation = new Laya.Quaternion();
            var rootScale = new Laya.Vector3(1, 1, 1);
            if (transMat) {
                transMat.decomposeTransRotScale(rootPosition, rootRotation, rootScale);
            }
            var objPosition = new Laya.Vector3();
            var objRotation = new Laya.Quaternion();
            var objScale = new Laya.Vector3(1, 1, 1);
            for (var i = 0; i < input.objData.length;) {
                var prefabIdx = input.objData[i++];
                var prefabId = input.prefabInfo[prefabIdx];
                objPosition.setValue(input.objData[i++] * GameConst.Int2Float, input.objData[i++] * GameConst.Int2Float, input.objData[i++] * GameConst.Int2Float);
                objRotation.x = input.objData[i++] * GameConst.Int2Float;
                objRotation.y = input.objData[i++] * GameConst.Int2Float;
                objRotation.z = input.objData[i++] * GameConst.Int2Float;
                objRotation.w = input.objData[i++] * GameConst.Int2Float;
                objScale.setValue(input.objData[i++] * GameConst.Int2Float, input.objData[i++] * GameConst.Int2Float, input.objData[i++] * GameConst.Int2Float);
                if (transMat) {
                    Laya.Vector3.transformCoordinate(objPosition, transMat, objPosition);
                    Laya.Quaternion.multiply(rootRotation, objRotation, objRotation);
                }
                var newPrefabIdx = output.prefabInfo.indexOf(prefabId);
                if (newPrefabIdx == -1) {
                    output.prefabInfo.push(prefabId);
                    newPrefabIdx = output.prefabInfo.length - 1;
                }
                output.objData.push(newPrefabIdx, objPosition.x, objPosition.y, objPosition.z, objRotation.x, objRotation.y, objRotation.z, objRotation.w, objScale.x, objScale.y, objScale.z);
            }
        }
    }

    class LevelLoader {
        static loadBrickCfg(input, transMat) {
            if (transMat) {
                transMat.decomposeTransRotScale(this.worldPosition, this.worldRotation, this.worldScale);
            }
            var brickCfg = {
                brickId: "",
                envs: {
                    prefabInfo: [],
                    objData: []
                },
                items: {
                    prefabInfo: [],
                    objData: []
                },
                bricks: {
                    prefabInfo: [],
                    objData: []
                }
            };
            var objsInfo;
            if (input.envs.prefabInfo.length > 0) {
                brickCfg.envs.prefabInfo = brickCfg.envs.prefabInfo.concat(input.envs.prefabInfo);
                objsInfo = input.envs;
                for (var i = 0; i < objsInfo.objData.length;) {
                    var prefabIdx = objsInfo.objData[i++];
                    this.objPosition.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                    this.objRotation.x = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objRotation.y = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objRotation.z = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objRotation.w = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objScale.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                    if (transMat) {
                        Laya.Vector3.transformCoordinate(this.objPosition, transMat, this.objPosition);
                        Laya.Quaternion.multiply(this.worldRotation, this.objRotation, this.objRotation);
                    }
                    brickCfg.envs.objData.push(prefabIdx, this.objPosition.x, this.objPosition.y, this.objPosition.z, this.objRotation.x, this.objRotation.y, this.objRotation.z, this.objRotation.w, this.objScale.x, this.objScale.y, this.objScale.z);
                }
            }
            if (input.items.prefabInfo.length > 0) {
                brickCfg.items.prefabInfo = brickCfg.items.prefabInfo.concat(input.items.prefabInfo);
                objsInfo = input.items;
                for (var i = 0; i < objsInfo.objData.length;) {
                    var prefabIdx = objsInfo.objData[i++];
                    this.objPosition.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                    this.objRotation.x = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objRotation.y = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objRotation.z = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objRotation.w = objsInfo.objData[i++] * GameConst.Int2Float;
                    this.objScale.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                    if (transMat) {
                        Laya.Vector3.transformCoordinate(this.objPosition, transMat, this.objPosition);
                        Laya.Quaternion.multiply(this.worldRotation, this.objRotation, this.objRotation);
                    }
                    brickCfg.items.objData.push(prefabIdx, this.objPosition.x, this.objPosition.y, this.objPosition.z, this.objRotation.x, this.objRotation.y, this.objRotation.z, this.objRotation.w, this.objScale.x, this.objScale.y, this.objScale.z);
                }
            }
            objsInfo = input.bricks;
            for (var i = 0; i < objsInfo.objData.length;) {
                var prefabIdx = objsInfo.objData[i++];
                var prefabId = objsInfo.prefabInfo[prefabIdx];
                this.objPosition.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                this.objRotation.x = objsInfo.objData[i++] * GameConst.Int2Float;
                this.objRotation.y = objsInfo.objData[i++] * GameConst.Int2Float;
                this.objRotation.z = objsInfo.objData[i++] * GameConst.Int2Float;
                this.objRotation.w = objsInfo.objData[i++] * GameConst.Int2Float;
                this.objScale.setValue(objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float, objsInfo.objData[i++] * GameConst.Int2Float);
                if (transMat) {
                    Laya.Vector3.transformCoordinate(this.objPosition, transMat, this.objPosition);
                    Laya.Quaternion.multiply(this.worldRotation, this.objRotation, this.objRotation);
                }
                var worldMat = new Laya.Matrix4x4();
                worldMat.identity();
                worldMat.setTranslationVector(this.objPosition);
                worldMat.setRotation(this.objRotation);
                BrickLoader.loadBrick(prefabId, brickCfg, worldMat);
            }
            return brickCfg;
        }
    }
    LevelLoader.objPosition = new Laya.Vector3();
    LevelLoader.objRotation = new Laya.Quaternion();
    LevelLoader.objScale = new Laya.Vector3(1, 1, 1);
    LevelLoader.worldPosition = new Laya.Vector3();
    LevelLoader.worldRotation = new Laya.Quaternion();
    LevelLoader.worldScale = new Laya.Vector3();

    class SceneManager extends fc.plugin.GameObj {
        constructor() {
            super(...arguments);
            this.mTask = [];
            this.mTaskRunning = false;
            this.objPosition = new Laya.Vector3();
            this.objRotation = new Laya.Quaternion();
            this.objScale = new Laya.Vector3(1, 1, 1);
        }
        init() {
            this.mEnvRoot = this.Sprite.addChild(new Laya.Sprite3D("envRoot"));
            this.mItemRoot = this.Sprite.addChild(new Laya.Sprite3D("itemRoot"));
            this.mPathRoot = this.Sprite.addChild(new Laya.Sprite3D("pathRoot"));
            this.mBrickRoot = this.Sprite.addChild(new Laya.Sprite3D("brickRoot"));
        }
        clearLevel() {
            this.mTaskRunning = false;
            this.mTask.splice(0);
            this.clearObj(this.mEnvRoot);
            this.clearObj(this.mItemRoot, true);
            this.clearObj(this.mPathRoot);
            this.clearObj(this.mBrickRoot);
            PathLoader.clearPath();
        }
        reset() {
            var lev = GameData.PlayerInfo.levelId;
            var randomId = -1;
            var totalLevs = ConfigManager.GameLevelList.list.length;
            if (lev >= totalLevs) {
                lev -= totalLevs;
                randomId = Math.floor(lev / 6);
                lev %= 6;
                lev = totalLevs - 1 - lev;
            }
            var levCfg = ConfigManager.GameLevelList.list[lev];
            this.clearLevel();
            this.loadBrick(ResConst.Prefab_Briack_Straight_24);
            this.loadBrick(ResConst.Prefab_StartBricks[lev % ResConst.Prefab_StartBricks.length]);
            this.loadLevel(levCfg, randomId);
            for (let index = 0; index < ResConst.Prefab_EndBricks.length; index++) {
                this.loadBrick(ResConst.Prefab_EndBricks[index]);
            }
        }
        loadBrick(brickId) {
            console.log("loadBrick:" + brickId);
            var comboBrickCfg = ConfigManager.ComboBrickList.list.find((val) => { return val.brickId == brickId; });
            if (comboBrickCfg != null) {
                this.mTask.push(comboBrickCfg);
            }
            else {
                var brickCfg = ConfigManager.BrickTracks.list.find(val => { return val.brickId == brickId; });
                if (brickCfg != null) {
                    comboBrickCfg = {
                        brickId: brickId,
                        envs: {
                            prefabInfo: [],
                            objData: []
                        },
                        items: {
                            prefabInfo: [],
                            objData: []
                        },
                        bricks: {
                            prefabInfo: [brickId],
                            objData: [0, 0, 0, 0, 0, 0, 0, -1, 1, 1, 1]
                        }
                    };
                    this.mTask.push(comboBrickCfg);
                }
            }
        }
        loadLevel(comboBrickCfg, randomId) {
            console.log("loadLevel:" + comboBrickCfg.brickId);
            if (randomId < 0) {
                this.mTask.push(comboBrickCfg);
            }
            else {
                var newComboBrickCfg = {
                    brickId: comboBrickCfg.brickId,
                    envs: comboBrickCfg.envs,
                    items: comboBrickCfg.items,
                    bricks: {
                        prefabInfo: [].concat(comboBrickCfg.bricks.prefabInfo),
                        objData: comboBrickCfg.bricks.objData
                    }
                };
                for (let index = 0; index < newComboBrickCfg.bricks.prefabInfo.length; index++) {
                    const brickId = newComboBrickCfg.bricks.prefabInfo[index];
                    const brickGroupId = ConfigManager.BricksMap[brickId];
                    if (brickGroupId != null) {
                        const brickGroup = ConfigManager.BrickGroups[brickGroupId];
                        if (brickGroup != null) {
                            newComboBrickCfg.bricks.prefabInfo[index] = brickGroup[randomId % brickGroup.length];
                            console.log(`${brickId}->${newComboBrickCfg.bricks.prefabInfo[index]}`);
                        }
                    }
                }
                this.mTask.push(newComboBrickCfg);
            }
        }
        onUpdate() {
            if (this.mTask.length > 0 && this.mTaskRunning == false) {
                this.runTask();
            }
        }
        runTask() {
            this.mTaskRunning = true;
            var worldMat = PathLoader.endWorldMat();
            var brickCfg = LevelLoader.loadBrickCfg(this.mTask.shift(), worldMat);
            var prefabList = [].concat(brickCfg.bricks.prefabInfo);
            if (brickCfg.envs.prefabInfo.length > 0) {
                prefabList = prefabList.concat(brickCfg.envs.prefabInfo);
            }
            if (brickCfg.items.prefabInfo.length > 0) {
                prefabList = prefabList.concat(brickCfg.items.prefabInfo);
            }
            fc.framework.Resource.loadSprite3dAsyn(prefabList, Laya.Handler.create(this, this.onBrickReady, [brickCfg]), null, null);
        }
        onBrickReady(comboBrickCfg) {
            if (comboBrickCfg.envs.objData.length > 0) {
                this.loadObjs(comboBrickCfg.envs, this.mEnvRoot);
            }
            if (comboBrickCfg.items.objData.length > 0) {
                this.loadObjs(comboBrickCfg.items, this.mItemRoot, true);
            }
            if (comboBrickCfg.bricks.objData.length > 0) {
                this.loadObjs(comboBrickCfg.bricks, this.mBrickRoot, false, true);
            }
            this.mTaskRunning = false;
            if (this.mTask.length == 0) {
                PathLoader.mergePath();
            }
        }
        loadObjs(objsInfo, root, hasScript, isPath) {
            for (var i = 0; i < objsInfo.objData.length;) {
                var prefabIdx = objsInfo.objData[i++];
                var prefabId = objsInfo.prefabInfo[prefabIdx];
                this.objPosition.setValue(objsInfo.objData[i++], objsInfo.objData[i++], objsInfo.objData[i++]);
                this.objRotation.x = objsInfo.objData[i++];
                this.objRotation.y = objsInfo.objData[i++];
                this.objRotation.z = objsInfo.objData[i++];
                this.objRotation.w = objsInfo.objData[i++];
                this.objScale.setValue(objsInfo.objData[i++], objsInfo.objData[i++], objsInfo.objData[i++]);
                if (prefabId == "Key" && GameData.KeyCollected == 3) {
                    continue;
                }
                var prefab = fc.framework.Resource.loadSprite3d(prefabId);
                if (prefab == null) {
                    continue;
                }
                var sprite = fc.plugin.ObjectPool.getSprite3d(prefab);
                sprite.name = prefabId;
                root.addChild(sprite);
                this.objPosition.cloneTo(sprite.transform.localPosition);
                sprite.transform.localPosition = sprite.transform.localPosition;
                this.objRotation.cloneTo(sprite.transform.localRotation);
                sprite.transform.localRotation = sprite.transform.localRotation;
                this.objScale.cloneTo(sprite.transform.localScale);
                sprite.transform.localScale = sprite.transform.localScale;
                sprite.active = true;
                if (hasScript) {
                    var cls = Laya.ClassUtils.getRegClass(`fc.game.${prefabId}`);
                    if (cls == null) {
                        console.log("can't find cls:" + prefabId);
                        continue;
                    }
                    var script = sprite.getComponent(cls);
                    if (script == null) {
                        script = sprite.addComponent(cls);
                    }
                    sprite.event(EventConst.ITEM_WAKEUP);
                }
                if (isPath) {
                    PathLoader.createPath(sprite);
                }
            }
        }
        clearObj(objRoot, hasScript) {
            while (objRoot && objRoot.numChildren > 0) {
                hasScript && objRoot.getChildAt(0).event(EventConst.ITEM_SLEEP);
                fc.plugin.ObjectPool.recoverSprite3d(objRoot.getChildAt(0));
            }
        }
        static showPath(pathRoot) {
            fc.framework.Resource.loadSprite3dAsyn("PathNode", Laya.Handler.create(this, this.onPrefabReady, [pathRoot]), null, null);
        }
        static onPrefabReady(pathRoot, prefab) {
            for (let index = 0; index < PathLoader.PathCount; index++) {
                const path = PathLoader.findPath(index);
                if (path.main != null) {
                    this.loadObjs(path.main, pathRoot, prefab);
                }
                else {
                    this.loadObjs(path.branchL, pathRoot, prefab);
                    this.loadObjs(path.branchR, pathRoot, prefab);
                }
            }
        }
        static loadObjs(pos, pathRoot, prefab) {
            for (var i = 0; i < pos.length;) {
                this.position.setValue(pos[i++], pos[i++], pos[i++]);
                this.rotation.x = pos[i++];
                this.rotation.y = pos[i++];
                this.rotation.z = pos[i++];
                this.rotation.w = pos[i++];
                var sprite = fc.plugin.ObjectPool.getSprite3d(prefab);
                pathRoot.addChild(sprite);
                this.position.cloneTo(sprite.transform.position);
                sprite.transform.position = sprite.transform.position;
                this.rotation.cloneTo(sprite.transform.rotation);
                sprite.transform.rotation = sprite.transform.rotation;
            }
        }
    }
    SceneManager.position = new Laya.Vector3();
    SceneManager.rotation = new Laya.Quaternion();

    class Item extends fc.plugin.GameObj {
        onEnable() {
            this.owner.on(EventConst.ITEM_TRIGGERD, this, this.onItemTriggered);
            this.owner.on(EventConst.ITEM_WAKEUP, this, this.onItemWakeup);
            this.owner.on(EventConst.ITEM_SLEEP, this, this.onItemSleep);
        }
        onDisable() {
            this.owner.off(EventConst.ITEM_TRIGGERD, this, this.onItemTriggered);
            this.owner.off(EventConst.ITEM_WAKEUP, this, this.onItemWakeup);
            this.owner.off(EventConst.ITEM_SLEEP, this, this.onItemSleep);
        }
    }

    class Collectable extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(objType) {
            this.Sprite.active = false;
            fc.framework.Audio.playSound(ResConst.Sound_Collected);
            var efc;
            if (objType == "Key") {
                efc = ResConst.Prefab_Get_Key_Efc;
                GameData.KeyCollected += 1;
                Laya.stage.event(EventConst.KEY_UPDATE, GameData.KeyCollected);
            }
            else {
                efc = ResConst.Prefab_Get_Coin_Efc;
                GameData.GoldCollected += 10;
                Laya.stage.event(fc.define.Event.GOLD_UPDATE, GameData.GoldCollected);
            }
            fc.plugin.Effect3d.createEffect({
                customId: efc,
                sign: efc,
                duaration: 1200,
                parent: this.owner.parent,
                isWorldSpace: true,
                position: this.obj.transform.position.clone()
            });
        }
        onItemWakeup() {
            this.isAwake = true;
            if (this.obj == null) {
                this.obj = this.Sprite.getChildAt(0);
            }
            this.Sprite.transform.localRotationEulerY = 0;
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
        }
        onUpdate() {
            this.Sprite.transform.localRotationEulerY += Laya.timer.delta * 0.001 * GameConst.ItemRotateSpd;
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                this.isAwake = false;
                this.onItemTriggered(this.Sprite.name);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class Flyer extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(args) {
            if (this.passenger) {
                fc.plugin.ObjectPool.recoverSprite3d(this.passenger.Sprite);
                this.passenger = null;
            }
            fc.framework.Audio.playSound(ResConst.Sound_Flyer);
            var position = this.Sprite.transform.position.clone();
            Laya.stage.event(EventConst.ADD_PASSENGER, position);
            this.Sprite.active = false;
        }
        onItemWakeup() {
            this.isAwake = true;
            if (this.obj == null) {
                this.obj = this.Sprite.getChildAt(0);
            }
            if (this.passenger) {
                fc.plugin.ObjectPool.recoverSprite3d(this.passenger.Sprite);
                this.passenger = null;
            }
            fc.framework.Resource.loadSprite3dAsyn(ResConst.Prefab_Passenger, Laya.Handler.create(this, this.onPrefabReady), null, ResConst.SubPkg_Skin);
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            if (this.passenger) {
                fc.plugin.ObjectPool.recoverSprite3d(this.passenger.Sprite);
                this.passenger = null;
            }
        }
        onUpdate() {
            this.obj.transform.localPositionY = 0.5 + 0.5 * Math.sin(Math.PI * 2 * (Date.now() % 5000) * 0.0002);
        }
        onPrefabReady(prefab) {
            var sprite = fc.plugin.ObjectPool.getSprite3d(prefab);
            this.obj.addChild(sprite);
            sprite.active = true;
            sprite.transform.localPosition.setValue(0, 0, 0);
            sprite.transform.localPosition = sprite.transform.localPosition;
            sprite.transform.localRotation.identity();
            sprite.transform.localRotation = sprite.transform.localRotation;
            this.passenger = Passenger.create(sprite);
            this.passenger.Animator.play(ResConst.Anim_Passenger_Fly);
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                this.isAwake = false;
                this.onItemTriggered(null);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class PadLock extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(args) {
            if (GameData.KeyCollected > 0) {
                GameData.KeyCollected -= 1;
                this.Animator.play(ResConst.Anim_PadLock_Open);
                fc.framework.Audio.playSound(ResConst.Sound_Unlock);
                Laya.stage.event(EventConst.Camera_2_Near);
                Laya.stage.event(EventConst.KEY_UPDATE, GameData.KeyCollected);
            }
            else {
                Laya.stage.event(EventConst.SHOW_SUCCESS);
            }
        }
        onItemWakeup() {
            this.isAwake = true;
            this.Animator.play(ResConst.Anim_PadLock_Default);
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                this.isAwake = false;
                this.onItemTriggered(null);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class Station extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
            this.passengerList = [];
        }
        onItemTriggered(args) {
        }
        onItemSleep() {
            var slot;
            for (let index = 0; index < 11; index++) {
                slot = this.Sprite.getChildByName("right").getChildAt(index);
                fc.plugin.Trigger3dListener.remove(slot.getComponent(Laya.PhysicsCollider), this);
                slot = this.Sprite.getChildByName("left").getChildAt(index);
                fc.plugin.Trigger3dListener.remove(slot.getComponent(Laya.PhysicsCollider), this);
            }
            for (let index = 0; index < this.passengerList.length; index++) {
                while (this.passengerList[index] != null && this.passengerList[index].numChildren > 0) {
                    fc.plugin.ObjectPool.recoverSprite3d(this.passengerList[index].getChildAt(0));
                }
            }
            this.passengerList.splice(0);
        }
        onItemWakeup() {
            this.isAwake = true;
            for (let index = 0; index < this.passengerList.length; index++) {
                while (this.passengerList[index] != null && this.passengerList[index].numChildren > 0) {
                    fc.plugin.ObjectPool.recoverSprite3d(this.passengerList[index].getChildAt(0));
                }
            }
            this.passengerList.splice(0);
            var slot;
            var slotIdxs = [];
            for (let index = 0; index < 11; index++) {
                slotIdxs.push(index);
                slot = this.Sprite.getChildByName("right").getChildAt(index);
                fc.plugin.Trigger3dListener.remove(slot.getComponent(Laya.PhysicsCollider), this);
                fc.plugin.Trigger3dListener.add(slot.getComponent(Laya.PhysicsCollider), this);
                slot.active = false;
                slot = this.Sprite.getChildByName("left").getChildAt(index);
                fc.plugin.Trigger3dListener.remove(slot.getComponent(Laya.PhysicsCollider), this);
                fc.plugin.Trigger3dListener.add(slot.getComponent(Laya.PhysicsCollider), this);
                slot.active = false;
            }
            var listIdx;
            var totalLevCount = ConfigManager.GameLevelList.list.length;
            var count = GameData.PlayerInfo.levelId < totalLevCount ? 2 : Math.min(10, 3 + Math.floor((GameData.PlayerInfo.levelId - totalLevCount) / 6));
            for (let index = 0; index < count && index < 11; index++) {
                listIdx = Math.floor(Math.random() * slotIdxs.length);
                slot = this.Sprite.getChildByName("right").getChildAt(slotIdxs[listIdx]);
                if (slot != null) {
                    this.passengerList.push(slot);
                }
                slotIdxs.splice(listIdx, 1);
                listIdx = Math.floor(Math.random() * slotIdxs.length);
                slot = this.Sprite.getChildByName("left").getChildAt(slotIdxs[listIdx]);
                if (slot != null) {
                    this.passengerList.push(slot);
                }
                slotIdxs.splice(listIdx, 1);
            }
            fc.framework.Resource.loadSprite3dAsyn(ResConst.Prefab_Passenger, Laya.Handler.create(this, this.onPrefabReady), null, ResConst.SubPkg_Skin);
        }
        onPrefabReady(prefab) {
            for (let index = 0; index < this.passengerList.length; index++) {
                const slot = this.passengerList[index];
                if (slot == null) {
                    console.warn("invaild slot idx");
                    continue;
                }
                slot.active = true;
                var sprite = fc.plugin.ObjectPool.getSprite3d(prefab);
                slot.addChild(sprite);
                sprite.active = true;
                sprite.transform.localPosition.setValue(0, 0, 0);
                sprite.transform.localPosition = sprite.transform.localPosition;
                sprite.transform.localRotation.identity();
                sprite.transform.localRotation = sprite.transform.localRotation;
                Passenger.create(sprite).Animator.play(ResConst.Anim_Passenger_Waving);
            }
        }
        on3dTriggerEnter(other, self, contact) {
            if (self.owner.numChildren > 0 && this.isAwake && GameData.IsInGame) {
                while (self.owner.numChildren) {
                    fc.plugin.ObjectPool.recoverSprite3d(self.owner.getChildAt(0));
                }
                var position = self.owner.transform.position.clone();
                Laya.stage.event(EventConst.ADD_PASSENGER, position);
                fc.framework.Audio.playSound(ResConst.Sound_Station);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class EndStation extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(arg) {
        }
        onItemWakeup() {
            this.isAwake = true;
            var slotRoot = this.Sprite.getChildByName("slot");
            for (let index = 0; index < slotRoot.numChildren; index++) {
                const slot = slotRoot.getChildAt(index);
                while (slot.numChildren > 0) {
                    fc.plugin.ObjectPool.recoverSprite3d(slot.getChildAt(0));
                }
            }
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            var slotRoot = this.Sprite.getChildByName("slot");
            for (let index = 0; index < slotRoot.numChildren; index++) {
                const slot = slotRoot.getChildAt(index);
                while (slot.numChildren > 0) {
                    fc.plugin.ObjectPool.recoverSprite3d(slot.getChildAt(0));
                }
            }
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                this.isAwake = false;
                console.log("onTriggerEnter:", this.Sprite.name);
                var slotRoot = this.Sprite.getChildByName("slot");
                Laya.stage.event(EventConst.REMOVE_PASSENGER, [[slotRoot.getChildAt(0), slotRoot.getChildAt(1)]]);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class ObstacleRock extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
            this.childPos = [];
            this.childRot = [];
        }
        onItemTriggered(args) {
            fc.plugin.Effect3d.createEffect({
                customId: ResConst.Prefab_Bomb_Efc,
                sign: ResConst.Prefab_Bomb_Efc,
                duaration: 1200,
                parent: this.owner.parent,
                isWorldSpace: true,
                position: this.Sprite.transform.position.clone()
            });
            fc.framework.Audio.playSound(ResConst.Sound_WallBreak);
            for (let index = 0; index < this.Sprite.numChildren; index++) {
                const child = this.Sprite.getChildAt(index);
                const rigidbody = child.getComponent(Laya.Rigidbody3D);
                if (rigidbody) {
                    rigidbody.isKinematic = false;
                    var dir = new Laya.Vector3();
                    Laya.Vector3.subtract(child.transform.position, args, dir);
                    Laya.Vector3.normalize(dir, dir);
                    Laya.Vector3.scale(dir, 50, dir);
                    rigidbody.applyImpulse(dir);
                    rigidbody.applyTorqueImpulse(dir);
                }
            }
            this.owner.timerOnce(2000, this, this.onItemSleep);
        }
        onItemWakeup() {
            this.isAwake = true;
            if (this.childPos.length == 0) {
                for (let index = 0; index < this.Sprite.numChildren; index++) {
                    const child = this.Sprite.getChildAt(index);
                    this.childPos.push(child.transform.localPosition.clone());
                    this.childRot.push(child.transform.localRotation.clone());
                }
            }
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            for (let index = 0; index < this.Sprite.numChildren; index++) {
                const child = this.Sprite.getChildAt(index);
                const rigidbody = child.getComponent(Laya.Rigidbody3D);
                if (rigidbody) {
                    rigidbody.isKinematic = true;
                }
                this.childPos[index].cloneTo(child.transform.localPosition);
                child.transform.localPosition = child.transform.localPosition;
                this.childRot[index].cloneTo(child.transform.localRotation);
                child.transform.localRotation = child.transform.localRotation;
            }
            this.Sprite.active = false;
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                console.log("onTriggerEnter:", this.Sprite.name);
                this.isAwake = false;
                var position = other.owner.transform.position.clone();
                position.y += 1;
                this.onItemTriggered(position);
                Laya.stage.event(EventConst.CARRIAGE_BOMB);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class ObstacleSide extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(args) {
            fc.plugin.Effect3d.createEffect({
                customId: ResConst.Prefab_Bomb_Efc,
                sign: ResConst.Prefab_Bomb_Efc,
                duaration: 1200,
                parent: this.owner.parent,
                isWorldSpace: true,
                position: this.obj.transform.position.clone()
            });
            fc.framework.Audio.playSound(ResConst.Sound_Bomb);
            Laya.Tween.to(this.obj.transform, { localScaleX: 1.1, localScaleY: 1.1, localScaleZ: 1.1 }, 500, Laya.Ease.bounceIn, Laya.Handler.create(this, this.onCompleted));
        }
        onItemWakeup() {
            this.isAwake = true;
            if (this.obj == null) {
                this.obj = this.Sprite.getChildAt(0);
            }
            this.obj.active = true;
            this.obj.transform.localScale.setValue(1, 1, 1);
            this.obj.transform.localScale = this.obj.transform.localScale;
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
        }
        onCompleted() {
            this.obj.active = false;
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                console.log("onTriggerEnter:", this.Sprite.name);
                this.isAwake = false;
                this.onItemTriggered(null);
                Laya.stage.event(EventConst.CARRIAGE_BOMB);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class ObstacleLong extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(args) {
        }
        onItemWakeup() {
            this.isAwake = true;
            if (this.obj == null) {
                this.obj = this.Sprite.getChildAt(0);
            }
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
        }
        onUpdate() {
            this.obj.transform.localRotationEulerX += Laya.timer.delta * 0.001 * GameConst.ItemRotateSpd;
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                this.isAwake = false;
                Laya.stage.event(EventConst.CARRIAGE_BOMB);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class ObstacleDontMove extends Item {
        constructor() {
            super(...arguments);
            this.isAwake = false;
        }
        onItemTriggered(args) {
        }
        onItemWakeup() {
            this.isAwake = true;
            if (this.obj == null) {
                this.obj = this.Sprite.getChildAt(0);
            }
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
            fc.plugin.Trigger3dListener.add(this.PhysicsCollider, this);
        }
        onItemSleep() {
            fc.plugin.Trigger3dListener.remove(this.PhysicsCollider, this);
        }
        onUpdate() {
            this.obj.transform.localRotationEulerY += Laya.timer.delta * 0.001 * GameConst.ItemRotateSpd;
        }
        on3dTriggerEnter(other, self, contact) {
            if (this.isAwake && GameData.IsInGame) {
                this.isAwake = false;
                Laya.stage.event(EventConst.CARRIAGE_BOMB);
            }
        }
        on3dTriggerExit(other, self, contact) {
        }
        on3dTriggerStay(other, self, contact) {
        }
    }

    class KeyShow extends Laya.Script {
        constructor() {
            super(...arguments);
            this.keyVal = null;
        }
        onAwake() {
            fc.view.linkView2Script(this, this.owner, [
                "keyVal"
            ]);
            Laya.stage.on(EventConst.KEY_UPDATE, this, this.onKeyUpdate);
            this.keyVal.value = GameData.PlayerInfo.keyCount.toString();
        }
        onDestroy() {
            Laya.stage.off(EventConst.KEY_UPDATE, this, this.onKeyUpdate);
        }
        onKeyUpdate(val) {
            if (val) {
                this.keyVal.value = val.toString();
            }
            else {
                this.keyVal.value = GameData.PlayerInfo.keyCount.toString();
            }
        }
    }

    var EventId = fc.define.Event;
    var GameFrame = fc.framework.GameFrame;
    var TextureCamera = fc.plugin.TextureCamera;
    var PlatformConfig = fc.platform.PlatformConfig;
    class GameLogic extends Laya.Script {
        constructor() {
            super();
            this.mLastUpdateTime = -1;
        }
        onAwake() {
            this.mGameRunning = false;
            Laya.ClassUtils.regClass("fc.game.KeyShow", KeyShow);
            Laya.ClassUtils.regClass("fc.game.Flyer", Flyer);
            Laya.ClassUtils.regClass("fc.game.Key", Collectable);
            Laya.ClassUtils.regClass("fc.game.BankNote", Collectable);
            Laya.ClassUtils.regClass("fc.game.PadLock", PadLock);
            Laya.ClassUtils.regClass("fc.game.Station", Station);
            Laya.ClassUtils.regClass("fc.game.LongObstacle", ObstacleLong);
            Laya.ClassUtils.regClass("fc.game.SideObstacle", ObstacleSide);
            Laya.ClassUtils.regClass("fc.game.DontMoveObstacle", ObstacleDontMove);
            Laya.ClassUtils.regClass("fc.game.RockObstacle", ObstacleRock);
            Laya.ClassUtils.regClass("fc.game.GateObstacle", ObstacleRock);
            Laya.ClassUtils.regClass("fc.game.MultiplierPartController1", EndStation);
            Laya.ClassUtils.regClass("fc.game.MultiplierPartController2", EndStation);
            Laya.ClassUtils.regClass("fc.game.MultiplierPartController3", EndStation);
            Laya.ClassUtils.regClass("fc.game.MultiplierPartController4", EndStation);
            Laya.ClassUtils.regClass("fc.game.MultiplierPartController5", EndStation);
            Laya.ClassUtils.regClass("fc.game.MultiplierPartController6", EndStation);
            Laya.stage.once(EventId.LAUNCH_COMPLETED, this, this.onGameLaunchReady);
            Laya.stage.on(EventId.GAME_HOME, this, this.onGameHome);
            Laya.stage.on(EventId.GAME_PREPARE, this, this.onGamePrepare);
            Laya.stage.on(EventId.GAME_START, this, this.onGameStart);
            Laya.stage.on(EventId.GAME_BACK_HOME, this, this.onGameHome);
            Laya.stage.on(EventId.GAME_OVER, this, this.onGameOver);
            Laya.stage.on(EventId.GAME_RELIVE, this, this.onGameRelive);
            Laya.stage.on(EventId.GAME_RESET, this, this.onGameReset);
            Laya.stage.on(EventId.GAME_WAKEUP, this, this.onGameWakeUp);
            Laya.stage.on(EventId.UI_VIEW_OPENED, this, this.onViewOpened);
            Laya.stage.on(EventId.UI_VIEW_CLOSED, this, this.onViewClosed);
            Laya.stage.on(EventId.CHANGE_CUR_MODEL, this, this.onChangeSkin);
            Laya.stage.on(EventConst.SHOW_SUCCESS, this, this.onGameSuccess);
            Laya.stage.on(EventConst.SHOW_FAILED, this, this.onGameFailed);
        }
        onDestroy() {
        }
        onUpdate() {
            if (this.mGameRunning && GameFrame.isGamePaused == false && GameFrame.gameSceneId == fc.define.SceneId.Game) {
                var deltaTime = Date.now() - this.mLastUpdateTime;
                this.mCoaster.update(deltaTime);
                this.mCamera.update(deltaTime, this.mCoaster.WorldMatrix);
                this.mCamera.Transform.position.cloneTo(this.mEvnRoot.transform.localPosition);
                this.mEvnRoot.transform.localPosition = this.mEvnRoot.transform.localPosition;
            }
            this.mLastUpdateTime = Date.now();
        }
        onGameLaunchReady() {
            console.log("GameLogic", EventId.LAUNCH_COMPLETED);
            GameFrame.scene3d.getChildByName("cameraTexture").addComponent(TextureCamera);
            this.mCamera = GameFrame.scene3d.getChildByName("cameraRoot").addComponent(Camera);
            this.mCamera.init();
            this.mCoaster = GameFrame.scene3d.getChildByName("coasterRoot").addComponent(Coaster);
            this.mCoaster.init();
            this.mEvnRoot = GameFrame.scene3d.getChildByName("globalEvn");
            this.mSceneManager = GameFrame.scene3d.addComponent(SceneManager);
            this.mSceneManager.init();
            this.mGameRunning = false;
            GameFrame.finishLoading();
        }
        onGameHome() {
            this.mGameRunning = false;
            GameData.GoldCollected = 0;
            GameData.KeyCollected = GameData.PlayerInfo.keyCount;
            this.mSceneManager.reset();
            this.mCamera.reset();
            this.mCoaster.reset();
        }
        onGamePrepare() {
            GameFrame.startGame();
        }
        onGameStart() {
            this.mCoaster.startGame();
            this.mGameRunning = true;
            this.mLastUpdateTime = Date.now();
        }
        onGameOver() {
        }
        onGameWakeUp() {
            this.mLastUpdateTime = Date.now();
            console.log("onGameWakeUp");
        }
        onGameReset() {
            this.mGameRunning = false;
            GameFrame.startGame();
        }
        onGameRelive() {
            Laya.stage.timerOnce(1000, this, function () {
                this.mGameRunning = true;
                GameFrame.relive2Game();
            });
        }
        onGameSuccess() {
            var playerInfo = PlatformConfig.playerInfo;
            if (playerInfo.isInGuide == 1) {
                GameFrame.savePlayerInfo({ isInGuide: 0 });
            }
            this.mCoaster.stopGame();
            GameFrame.savePlayerInfo({ keyCount: GameData.KeyCollected });
            this.mGameRunning = false;
            GameFrame.showSuccessed({ award: GameData.GoldCollected });
            GameFrame.closeView("Game");
            fc.framework.Audio.stopAll();
            fc.framework.Audio.playSound(ResConst.Sound_Yell);
        }
        onGameFailed() {
            this.mCoaster.stopGame();
            this.mGameRunning = false;
            GameFrame.showFailed();
            GameFrame.closeView("Game");
            fc.framework.Audio.playSound(ResConst.Sound_Lose);
        }
        onViewClosed(viewName, viewId) {
            console.log("onViewClosed", viewName);
            if (viewId == fc.view.ViewId.Store) {
                this.mCoaster.changeCarriage(GameData.GoodsCfg[0][GameData.PlayerInfo.goodsInUse[0]].prefab, GameData.GoodsCfg[1][GameData.PlayerInfo.goodsInUse[1]].prefab);
            }
        }
        onViewOpened(viewName, viewId) {
            console.log("onViewOpened", viewName);
        }
        onChangeSkin(prefabId, showAnim, goodsData) {
            if (goodsData.type == 0) {
                this.mCoaster.changeCarriage(prefabId, GameData.GoodsCfg[1][GameData.PlayerInfo.goodsInUse[1]].prefab);
            }
            else {
                this.mCoaster.changeCarriage(GameData.GoodsCfg[0][GameData.PlayerInfo.goodsInUse[0]].prefab, prefabId);
            }
        }
    }

    var PlatformConfig$1 = fc.platform.PlatformConfig;
    class Main {
        constructor() {
            if (window["Laya3D"])
                Laya3D.init(GameConfig.width, GameConfig.height);
            else
                Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
            Laya["Physics"] && Laya["Physics"].enable();
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            Laya.stage.bgColor = "#ffffff";
            Laya.stage.scaleMode = GameConfig.scaleMode;
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true")
                Laya.enableDebugPanel();
            if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"])
                Laya["PhysicsDebugDraw"].enable();
            if (GameConfig.stat)
                Laya.Stat.show();
            Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
        }
        onVersionLoaded() {
            Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
        }
        onConfigLoaded() {
            PlatformConfig$1.init();
            Laya.stage.addComponent(GameLogic);
        }
    }
    new Main();

}());
